@rem ************************************************************************
@rem  Licensed Material - Property of IBM
@rem 
@rem  5724-M24 
@rem 
@rem  (c) Copyright IBM Corp. 2007.  All rights reserved.
@rem 
@rem  US Government Users Restricted Rights - Use, duplication or
@rem  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@rem ************************************************************************

@rem ************************************************************************
@rem  Update Monitor Development Toolkit 6.0.2 or 6.0.2.1
@rem  by applying required fixes for Process Server
@rem ************************************************************************

@echo off
setlocal
set SAVE_RC=0
@rem set up logs directory
SET MY_DIR=%CD%
if exist "%MY_DIR%\logs" goto setlog 
mkdir "%MY_DIR%\logs"
:setlog
set TK_LOG="%MY_DIR%\logs\iFix.log"

echo Start Monitor Development Toolkit iFix update...
echo Start Monitor Development Toolkit iFix update... >%TK_LOG%
time /t >>%TK_LOG%

@rem *********************************************************
@rem define input prompts for Toolkit
@rem only need Monitor home because it is under WID. If we know WID home
@rem we can find Process Server home and the profile home.
@rem *********************************************************
set MON_PROMPT1=Type the path to the WebSphere Business Monitor Toolkit installation directory
set MON_PROMPT2=under the WebSphere Integration Developer (WID) directory
set MON_PROMPT=%MON_PROMPT1% %MON_PROMPT2%
set CELL_PROMPT=Type the cell name
set NODE_PROMPT=Type the node name

@rem *********************************************************
@rem define default values
@rem *********************************************************
set MON_HOME=C:\IBM\WebSphere\ID\602\WBMonitor
if not "%WBMONITOR_HOME%"=="" set MON_HOME=%WBMONITOR_HOME%
set WAS_PROFILE_NAME=wbmonitor
for /F %%v in ('hostname') do set myhost=%%v
set CELL_NAME1=%myhost%Node01Cell
set NODE_NAME1=Node01
       
@rem get Monitor home dir       
:getmon
set INPUT=
set /p INPUT=%MON_PROMPT% [enter=%MON_HOME%]: 
IF NOT "%INPUT%"=="" set MON_HOME=%INPUT%
if exist "%MON_HOME%" goto getwas
echo Monitor home - "%MON_HOME%" does not exist
call :logecho "Monitor home: %MON_HOME% does not exist"
set SAVE_RC=8
set MON_HOME=
goto getout

@rem get WAS home dir       
:getwas
set WID_HOME=%MON_HOME%\..
set WAS_HOME1=%WID_HOME%\runtimes\bi_v6
if exist "%WAS_HOME1%" goto getprof
echo Process Server home - "%WAS_HOME1%" does not exist
call :logecho "Process Server home: %WAS_HOME1% does not exist"
set SAVE_RC=8
goto getout

@rem get profile dir       
:getprof
set WAS_PROFILE_HOME=%WID_HOME%\pf\%WAS_PROFILE_NAME%
if exist "%WAS_PROFILE_HOME%" goto getcell 
echo Profile home - "%WAS_PROFILE_HOME%" does not exist
call :logecho "Profile home: %WAS_PROFILE_HOME% does not exist"
set SAVE_RC=8
goto getout

@rem get cell name       
:getcell
set INPUT=
set /p INPUT=%CELL_PROMPT% [enter=%CELL_NAME1%]: 
IF NOT "%INPUT%"=="" set CELL_NAME1=%INPUT%
if exist "%WAS_PROFILE_HOME%\config\cells\%CELL_NAME1%" goto getnode 
echo Cell home - "%WAS_PROFILE_HOME%\config\cells\%CELL_NAME1%" does not exist
call :logecho "Cell home - %WAS_PROFILE_HOME%\config\cells\%CELL_NAME1% does not exist"
set SAVE_RC=8
goto getout
 
@rem get node name       
:getnode      
set INPUT=
set /p INPUT=%NODE_PROMPT% [enter=%NODE_NAME1%]: 
IF NOT "%INPUT%"=="" set NODE_NAME1=%INPUT%
if exist "%WAS_PROFILE_HOME%\config\cells\%CELL_NAME1%\nodes\%NODE_NAME1%" goto fix 
echo Node home - "%WAS_PROFILE_HOME%\config\cells\%CELL_NAME1%\nodes\%NODE_NAME1%" does not exist
call :logecho "Node home: %WAS_PROFILE_HOME%\config\cells\%CELL_NAME1%\nodes\%NODE_NAME1% does not exist"
set SAVE_RC=8
goto getout

@rem ************************************************************************
@rem  Apply iFixes needed by Toolkit 6.0.2 or 6.0.2.1
@rem  prepareFix.bat is the renamed version of upgradeToolkit.bat
@rem ************************************************************************
:fix
@rem stop the server so Toolkit scripts can run
echo Stop server server1 ...
call :logecho "Stop server server1 ..."
call "%WAS_PROFILE_HOME%\bin\stopServer" server1 >>%TK_LOG% 2>&1

copy updateToolkit.jar upgradeToolkit.jar
call :logecho "Calling prepareFix.bat"
call prepareFix.bat 6021 "%MON_HOME%" %CELL_NAME1% %NODE_NAME1%
set SAVE_RC=%errorlevel%
del upgradeToolkit.jar
if %SAVE_RC% NEQ 0 goto cmdFailed

goto end

@rem ************************************************************************
:logecho
@rem ************************************************************************
echo ******************************************************** >> %TK_LOG%
echo %~1 >> %TK_LOG% 
echo ******************************************************** >> %TK_LOG%
time /t >>%TK_LOG% 
GOTO :EOF

@rem ************************************************************************
:cmdFailed
@rem ************************************************************************
echo Error: command failed, error code = %SAVE_RC%
call :logecho "Error: command failed, return code = %SAVE_RC%"
goto getout

@rem ************************************************************************
:getout
@rem ************************************************************************
echo Update failed! 
echo ******************************************************** >> %TK_LOG%
echo Update failed! >>%TK_LOG%
echo ******************************************************** >> %TK_LOG%
goto end2

@rem ************************************************************************
:end
@rem ************************************************************************
echo Update finished.
echo ******************************************************** >> %TK_LOG%
echo Update finished. >>%TK_LOG%
echo ******************************************************** >> %TK_LOG%
:end2
time /t >>%TK_LOG%

rem copy log file to Monitor home
IF ".%MON_HOME%"=="." goto skipcopy
set MON_LOG_DIR=%MON_HOME%\update\6.0.2.1-WBI-MONITOR-UPK417107.install\logs
if exist "%MON_LOG_DIR%" goto copylog 
mkdir "%MON_LOG_DIR%"
:copylog
copy %TK_LOG% "%MON_LOG_DIR%\"

:skipcopy
exit /b %SAVE_RC%
